%define distrib     TurboLinux
%define name        postgresql
%define ver         7.0
%define rel         12
%define prefix      /usr


Summary:PostgreSQL DB.
Name: %{name}
Version: %{ver}
Release: %{rel}
Group: Applications/Databases
Copyright: BSD
Source0: %{name}-%{ver}.tar.gz
Source1: postgresql.init-%{ver}
Source2: http://www.retep.org.uk/postgres/jdbc7.0-1.1.jar
Source3: http://www.retep.org.uk/postgres/jdbc7.0-1.2.jar
Source4: regress_test.sh
Source5: README.rpm.postgresql-7.0
Patch0: %{name}-%{ver}-Makefile.global.in.patch
Patch1: %{name}-%{ver}-Makefile.PL.patch
Patch2: %{name}-%{ver}-pgaccess_Makefile.patch
Patch3: %{name}-%{ver}-regress.patch
Patch4: %{name}-%{ver}-syslog.patch
URL: ftp://ftp.postgresql.org/pub/v7.0/
Serial: 2000052401
Distribution: %{distrib}
Obsoletes: postgresql
BuildRoot: /var/tmp/%{name}-%{ver}-root
#Requires: 
#Buildrequires:
PreReq: /bin/bash /sbin/chkconfig /sbin/ldconfig /usr/sbin/useradd
#NoSource: 0

%description
PostgreSQL is an advanced Object-Relational database management system
(DBMS) that supports almost all SQL constructs (including
transactions, subselects and user-defined types and functions). The
postgresql package includes the client programs and libraries that
you'll need to access a PostgreSQL DBMS server.  These PostgreSQL
client programs are programs that directly manipulate the internal
structure of PostgreSQL databases on a PostgreSQL server. These client
programs can be located on the same machine with the PostgreSQL
server, or may be on a remote machine which accesses a PostgreSQL
server over a network connection. This package contains the client
libraries for C and C++, as well as command-line utilities for
managing PostgreSQL databases on a PostgreSQL server. 

If you want to manipulate a PostgreSQL database on a remote PostgreSQL
server, you need this package. You also need to install this package
if you're installing the postgresql-server package.

%package server
Summary: The programs needed to create and run a PostgreSQL server.
Group: Applications/Databases
Prereq: /usr/sbin/useradd
Requires: postgresql = %{ver}

%description server
The postgresql-server package includes the programs needed to create
and run a PostgreSQL server, which will in turn allow you to create
and maintain PostgreSQL databases.  PostgreSQL is an advanced
Object-Relational database management system (DBMS) that supports
almost all SQL constructs (including transactions, subselects and
user-defined types and functions). You should install
postgresql-server if you want to create and maintain your own
PostgreSQL databases and/or your own PostgreSQL server. You also need
to install the postgresql and postgresql-devel packages.

%package man
Summary: PostgreSQL man Documents.
Group: Applications/Databases

%description man
These man Documents is Good.


%package devel
Summary: PostgreSQL development header files and libraries.
Group: Development/Libraries
Obsoletes: postgresql-devel
Requires: postgresql = %{ver}

%description devel
The postgresql-devel package contains the header files and libraries
needed to compile C or C++ applications which will directly interact
with a PostgreSQL database management server and the ecpg Embedded C
Postgres preprocessor. You need to install this package if you want to
develop applications which will interact with a PostgreSQL server. If
you're installing postgresql-server, you need to install this
package.

%package tcl
Summary: A Tcl-based GUI front end for psql and related PostgreSQL clients.
Group: Applications/Databases
Obsoletes: postgresql-tcl
Requires: tcl >= 8.0, tk >= 8.0, postgresql = %{ver}

%description tcl
PostgreSQL is an advanced Object-Relational database management
system.  The postgresql-tcl package contains the pgaccess
program. Pgaccess is a graphical front end, written in Tcl, for the
psql and related PostgreSQL client programs.

%package odbc
Summary: The ODBC driver needed for accessing a PostgreSQL DB using ODBC.
Group: Applications/Databases
Obsoletes: postgresql-odbc
Requires: postgresql = %{ver}

%description odbc
PostgreSQL is an advanced Object-Relational database management
system. The postgresql-odbc package includes the ODBC (Open DataBase
Connectivity) driver and sample configuration files needed for
applications to access a PostgreSQL database using ODBC.

%package jdbc
Summary: Files needed for Java programs to access a PostgreSQL database.
Group: Applications/Databases
Obsoletes: postgresql-jdbc
Requires: postgresql = %{ver}

%description jdbc
PostgreSQL is an advanced Object-Relational database management
system. The postgresql-jdbc package includes the .jar file needed for
Java programs to access a PostgreSQL database.

%package perl
Summary: Development module needed for Perl code to access a PostgreSQL DB.
Group: Applications/Databases
Obsoletes: postgresql-perl
Requires: perl >= 5.005, postgresql = %{ver}

%description perl
PostgreSQL is an advanced Object-Relational database management
system. The postgresql-perl package includes a module for developers
to use when writing Perl code for accessing a PostgreSQL database.

%package python
Summary: Development module for Python code to access a PostgreSQL DB.
Group: Applications/Databases
Requires: python >= 1.5, postgresql = %{ver}

%description python
PostgreSQL is an advanced Object-Relational database management
system.  The postgresql-python package includes a module for
developers to use when writing Python code for accessing a PostgreSQL
database.

%package test
Summary: The test suite distributed with PostgreSQL.
Group: Applications/Databases
Requires: postgresql = %{ver}

%description test
PostgreSQL is an advanced Object-Relational database management
system. The postgresql-test package includes the sources and pre-built
binaries of various tests for the PostgreSQL database management
system, including regression tests and benchmarks.

%package pgbench
Summary:  postgreSQL benchmark program contributed to by Ishii Tatsuo.
Group: Applications/Databases
Requires: postgresql = %{ver}                

%description pgbench
PostgreSQL is an advanced Object-Relational database management
system. The postgresql-pgbench package includes the binary programy
This program was contributed to by Ishii Tatsuo.


%changelog
* Thu May 25 2000 kazuhiro Taga <tagache@turbolinux.co.jp>
- Getted postgresql.init-7.0 & README.rpm.postgresql-7.0
- (created by lamar.owen for postgresql-7.0-2.src.rpm)
- added postgresql-7.0-regress.patch
- added postgresql-7.0-syslog.patch
- added regress_test.sh

* Wed May 24 2000 Kazuhiro Taga <tagache@turbolinux.co.jp>
- Sub packaged pgbench

* Tue May 23 2000 Kazuhiro Taga <tagache@turbolinux.co.jp>
- Integrated spec file based on lamar.owen@wgcr.org style(ver 6.5.3)

* Wed May 18 2000 Kazuhiro Taga <tagache@turbolinux.co.jp>
- Packaged Postgresql 7.0 Relese first
- Appointed multibyte option in UNICODE 


#--------------------------------------------------
%prep
rm -rf $RPM_BUILD_ROOT


%setup -n %{name}-%{ver}
%patch0 -p1 -b .Makefile.global.in
%patch1 -p1 -b .Makefile.PL
%patch2 -p1 -b .pgaccess_Makefile
%patch3 -p1 -b .regress
%patch4 -p1 -b .syslog

# Fix perl scripts
for i in `find . -type f | xargs grep '/usr/local/bin/perl' | cut -d : -f 1`
    do (sed 's/\/usr\/local\/bin\/perl/\/usr\/bin\/perl/g' $i > $i.fixed; mv -f $i.fixed $i);
done;

# Fix python scripts
for i in `find . -type f | xargs grep '/usr/local/bin/python' | cut -d : -f 1`
    do (sed 's/\/usr\/local\/bin\/python/\/usr\/bin\/python/g' $i > $i.fixed; mv -f $i.fixed $i);
done;

%build
pushd src
# XXX libtoolize dinna work
cp /usr/share/libtool/config.* .
%ifarch alpha
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr \
        --enable-hba --enable-locale \
        --with-perl --enable-multibyte \
        --with-tcl --with-tk --with-x \
        --with-odbc --with-java --with-python \
        --with-template=linux_alpha
%else
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr \
        --enable-hba --enable-locale \
        --with-perl --enable-multibyte \
        --with-tcl --with-tk --with-x \
        --with-odbc --with-java --with-python
%endif

make all

pushd interfaces/python
cp /usr/lib/python1.5/config/Makefile.pre.in .
echo *shared* > Setup
echo _pg pgmodule.c -I../../include -I../libpq -L../libpq -lpq -lcrypt >> Setup
make -f Makefile.pre.in boot
make
popd
popd

make all -C contrib/pgbench
make all -C src/test

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT%{prefix}/{include/pgsql,lib/pgsql/test,bin,man}
mkdir -p $RPM_BUILD_ROOT%{prefix}/lib/perl5/site_perl/5.005/%{_arch}-linux/auto/Pg
mkdir -p $RPM_BUILD_ROOT%{prefix}/lib/python1.5/site-packages

make POSTGRESDIR=$RPM_BUILD_ROOT%{prefix} PREFIX=$RPM_BUILD_ROOT%{prefix} -C src install
make POSTGRESDIR=$RPM_BUILD_ROOT%{prefix} PREFIX=$RPM_BUILD_ROOT%{prefix} -C src/interfaces/perl5 install
make POSTGRESDIR=$RPM_BUILD_ROOT%{prefix} PREFIX=$RPM_BUILD_ROOT%{prefix} -C contrib/pgbench install
make install PGDOCS=../Documents POSTMANDIR=$RPM_BUILD_ROOT%{prefix}/man -C doc

install -m 755 %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/postgresql

install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{prefix}/lib/pgsql
install -m 755 %{SOURCE3} $RPM_BUILD_ROOT%{prefix}/lib/pgsql

install -m 644 %{SOURCE5} .

strip `file $RPM_BUILD_ROOT%{prefix}/bin/* | awk -F':' '/executable/ { print $1 }'`

find $RPM_BUILD_ROOT%{prefix}/lib/perl5  -type f -o -type l | sed -e "s|$RPM_BUILD_ROOT||g" > perl.fileslist
find $RPM_BUILD_ROOT%{prefix}/man/man1  -type f -o -type l | sed -e "s|$RPM_BUILD_ROOT||g" > man.fileslist
find $RPM_BUILD_ROOT%{prefix}/man/manl  -type f -o -type l | sed -e "s|$RPM_BUILD_ROOT||g" >> man.fileslist

mkdir -p pgaccess
mkdir -p perl5
mkdir -p python

cp -a src/bin/pgaccess/doc/html		pgaccess
cp -a src/bin/pgaccess/demo		pgaccess

cp -a src/interfaces/perl5/test.pl	perl5
cp -a src/interfaces/perl5/eg		perl5

cp -a src/interfaces/python/tutorial	python

cp -a contrib/pgbench/README.jis	pgbench_README.jis

install -m 755 src/interfaces/python/_pgmodule.so	$RPM_BUILD_ROOT%{prefix}/lib/python1.5/site-packages/
install -m 755 src/interfaces/python/*.py		$RPM_BUILD_ROOT%{prefix}/lib/python1.5/site-packages/

install -d -m 700 $RPM_BUILD_ROOT/var/lib/pgsql/data

cp -a src/test $RPM_BUILD_ROOT%{prefix}/lib/pgsql
install -m 0755 src/config.guess $RPM_BUILD_ROOT%{prefix}/lib/pgsql
install -m 0755 contrib/spi/refint.so $RPM_BUILD_ROOT%{prefix}/lib/pgsql/test/regress
install -m 0755 contrib/spi/autoinc.so $RPM_BUILD_ROOT%{prefix}/lib/pgsql/test/regress
install -m 755 %{SOURCE4} $RPM_BUILD_ROOT%{prefix}/lib/pgsql/test/regress

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%pre server
useradd -M -o -r -d /var/lib/pgsql -s /bin/bash \
        -c "PostgreSQL Server" -u 40 postgres >/dev/null 2>&1 || :

%post -p /sbin/ldconfig server

%preun server
if [ $1 = 0 ] ; then
        chkconfig --del postgresql
fi

%postun server
/sbin/ldconfig
if [ $1 = 0 ] ; then
        userdel postgres >/dev/null 2>&1 || : 
fi

%post -p /sbin/ldconfig odbc
%postun -p /sbin/ldconfig odbc

%post -p /sbin/ldconfig tcl
%postun -p /sbin/ldconfig tcl

%clean
rm -rf $RPM_BUILD_ROOT
rm -f perl.fileslist
rm -f man.fileslist


%files
%defattr(-,root,root)
%attr(755,root,root) /usr/lib/libpq.so*
%attr(755,root,root) /usr/lib/libecpg.so*
%attr(755,root,root) /usr/lib/libpq++.so*
%attr(755,root,root) /usr/lib/libpgeasy.so*
%attr(755,root,root) /usr/lib/plpgsql.so
/usr/bin/createdb
/usr/bin/createlang
/usr/bin/createuser
/usr/bin/dropdb
/usr/bin/droplang
/usr/bin/dropuser
/usr/bin/pg_dump
/usr/bin/pg_dumpall
/usr/bin/pg_id
/usr/bin/psql
/usr/bin/vacuumdb
%doc Documents/
%doc pgaccess/
%doc perl5/
%doc python/
%doc pgbench_README.jis
%doc README.rpm.postgresql-7.0

%files man -f man.fileslist
%defattr(-,root,root)

%files server
%defattr(-,root,root)
%config /etc/rc.d/init.d/postgresql
/usr/bin/initdb
/usr/bin/initlocation
/usr/bin/ipcclean
/usr/bin/pg_ctl
/usr/bin/pg_encoding
/usr/bin/pg_passwd
/usr/bin/pg_upgrade
/usr/bin/pg_version
/usr/bin/postgres
/usr/bin/postmaster
/usr/lib/pgsql/global1.bki.source
/usr/lib/pgsql/global1.description
/usr/lib/pgsql/local1_template1.bki.source
/usr/lib/pgsql/local1_template1.description
/usr/lib/pgsql/pg_geqo.sample
/usr/lib/pgsql/pg_hba.conf.sample
/usr/lib/pgsql/pg_options.sample
/usr/lib/pgsql/postmaster.opts.default.sample
%attr(700,postgres,postgres) %dir /var/lib/pgsql/

%files devel
%defattr(-,root,root)
/usr/include/pgsql/
/usr/lib/libecpg.a
/usr/lib/libpgeasy.a
/usr/lib/libpgtcl.a
/usr/lib/libpq++.a
/usr/lib/libpq.a
/usr/lib/libpsqlodbc.a
/usr/bin/ecpg

%files tcl
%defattr(-,root,root)
%attr(755,root,root) /usr/lib/libpgtcl.so*
%attr(755,root,root) /usr/lib/pltcl.so
/usr/lib/pgsql/pgaccess/
/usr/bin/pgaccess
/usr/bin/pgtclsh 
/usr/bin/pgtksh  

%files odbc
%defattr(-,root,root)
%attr(755,root,root) /usr/lib/libpsqlodbc.so*
/usr/lib/pgsql/odbcinst.ini

%files jdbc
%defattr(-,root,root)
/usr/lib/pgsql/jdbc7.0-1.1.jar 
/usr/lib/pgsql/jdbc7.0-1.2.jar 

%files perl -f perl.fileslist
%defattr(-,root,root)
%dir /usr/lib/perl5/site_perl/5.005/%{_arch}-linux/auto/Pg

%files python
%defattr(-,root,root)
/usr/lib/python1.5/site-packages/_pgmodule.so
/usr/lib/python1.5/site-packages/*.py

%files  test
%defattr(-,postgres,postgres)
%attr(755,postgres,postgres) /usr/lib/pgsql/config.guess
/usr/lib/pgsql/test/

%files pgbench 
%defattr(-,root,root)
/usr/bin/pgbench
